<template>
  <ObInput
    ref="input"
    :value="value"
    :data-qa="dataQa"
    :readonly="isDisabled"
    :type="inputType"
    :is-convert-money="isConvertMoney"
    :class="[
      'obInputField',
      highlightClass,
      { 'isWide': isWide },
      { 'align-right': column.isAlignRight }
    ]"
    :sub-title="currentSubTitle"
    @focus="onFieldFocus"
    @blur="onFieldBlur"
    @input="onInput"
  />
</template>

<script>
import ObInput from '../../../obInput'
import tableRowMixin from './tableRowMixin'

export default {
  name: 'TableRowInput',
  components: {
    ObInput
  },
  mixins: [
    tableRowMixin
  ],
  data () {
    return {
      initialWidth: 0,
      isWide: false
    }
  },
  computed: {
    inputType () {
      switch (this.valueType) {
        case 'INTEGER':
          return 'number:strict'

        case 'NUMERIC':
          return 'number'

        case 'FLOAT':
        case 'MONEY':
          return 'money:2'

        default:
          return 'text'
      }
    },
    currentSubTitle () {
      const subTitleMap = {
        MONEY: '₽'
      }

      return subTitleMap[this.valueType] || null
    },
    isConvertMoney () {
      return ['MONEY'].includes(this.valueType)
    }
  },
  watch: {
    'data.item': {
      handler () {
        this.fetchValue()
        this.checkWidth(this.value)
      },
      immediate: true
    }
  },
  mounted () {
    this.initialWidth = this.$refs.input.$el.clientWidth
  },
  methods: {
    fetchValue () {
      let value

      if (this.column.isEditHtml) {
        value = this.getTableCellHtml(this.data.item, this.column)
      } else {
        value = this.data.item[this.column.key]
      }

      if (value != null && !['string', 'number'].includes(typeof value)) {
        // Manually cast type, because if field editing is disabled,
        // text field will be used for any content - arrays, boolean
        value = String(value)
      }

      this.value = value
    },
    async onInput (newValue) {
      // By default empty <ObInput> is equal to empty string,
      // but we need to pass 'null' in this case
      if (newValue !== '') {
        newValue = this.inputType !== 'text' ? Number(newValue) : newValue
      } else {
        newValue = null
      }

      // Checking for new value, because inputs with the
      // type 'number' and 'money' triggering '@input' event
      // after '@blur' event, so new value can be equal to the
      // old value, which will be triggering unnecessary data saving in table
      if (this.value !== newValue) {
        await this.onFieldChanged(newValue)
      }

      this.checkWidth(newValue)
    },
    checkWidth (value) {
      this.$nextTick().then(() => {
        if (!value) {
          this.isWide = false
        } else {
          this.isWide = this.$refs.input?.$refs.input.scrollWidth > this.initialWidth - 25 // -25px to ignore padding
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
  .align-right::v-deep input.input {
    text-align: right;
  }
</style>
